package com.example.kpprinter;

import android.app.Activity;
import android.widget.Toast;

import com.example.kpprinter.java.AndroidPrintSdk;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** KpprinterPlugin */
public class KpprinterPlugin implements MethodCallHandler , EventChannel.StreamHandler{
  private Activity mActivity;


  public KpprinterPlugin(Activity activity) {
    mActivity = activity;
    AndroidPrintSdk.getInstance(mActivity).initPrint();

  }

  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    KpprinterPlugin instance = new KpprinterPlugin(registrar.activity());
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "kpprinter");
    channel.setMethodCallHandler(instance);


    EventChannel printResult = new EventChannel(registrar.messenger(), "printer_printerSearched");
    printResult.setStreamHandler(instance);

  }

  @Override
  public void onMethodCall(MethodCall call, final Result result) {
    switch (call.method) {
      case "printer_search":
        System.out.print(call.method);
        AndroidPrintSdk.getInstance(mActivity).searchPrint((List<Map<String, String>>) call.arguments);
        AndroidPrintSdk.getInstance(mActivity).setOnDeviceSearchListener(new AndroidPrintSdk.DeviceSearchListener() {
          @Override
          public void searchSuccess() {
            result.success("success");
//            Toast.makeText(mActivity,"flutter搜索成功",Toast.LENGTH_SHORT).show();
          }

          @Override
          public void searchFail(){
            result.success("fail");
//            Toast.makeText(mActivity,"flutter搜索失败",Toast.LENGTH_SHORT).show();
          }
        });

        AndroidPrintSdk.getInstance(mActivity).setOnLocationPermissionListener(new AndroidPrintSdk.LocationPermissionListener() {
          @Override
          public void close() {
            result.success("false");
//            Toast.makeText(mActivity,"flutter请开启gps",Toast.LENGTH_SHORT).show();
          }
        });

        AndroidPrintSdk.getInstance(mActivity).setOnBlueToothEnableListener(new AndroidPrintSdk.BlueToothEnableListener() {
          @Override
          public void enableFalse() {
            result.success("false");
//            Toast.makeText(mActivity,"flutter请开启蓝牙",Toast.LENGTH_SHORT).show();

          }
        });
        break;
      case "printer_connectAPrinter":

        break;
      case "printer_connectAndPrint":
        AndroidPrintSdk.getInstance(mActivity).connectAndPrint((Map<String, Object>) call.arguments);



        AndroidPrintSdk.getInstance(mActivity).setOnDeviceConnectListener(new AndroidPrintSdk.DeviceConnectListener() {
          @Override
          public void connectFalse() {
            result.success("false");
//            Toast.makeText(mActivity, "Flutter连接打印机失败", Toast.LENGTH_SHORT).show();

          }

          @Override
          public void connectSuccess() {
            mActivity.runOnUiThread(new Runnable() {
              @Override
              public void run() {
//                result.success("true");
//                Toast.makeText(mActivity, "Flutter连接打印机成功", Toast.LENGTH_SHORT).show();
              }
            });
          }

          @Override
          public void connectUnConnect() {
//            Toast.makeText(mActivity, "Flutter还没连接打印机", Toast.LENGTH_SHORT).show();
          }
        });

        AndroidPrintSdk.getInstance(mActivity).setOnPrintResultListener(new AndroidPrintSdk.PrintResultListener() {
          @Override
          public void printSuccess() {
//                Toast.makeText(mActivity, "打印成功", Toast.LENGTH_LONG).show();
                result.success("true");
          }

          @Override
          public void printFail() {
                result.success("false");
//                Toast.makeText(mActivity, "Flutter打印失败", Toast.LENGTH_LONG).show();
              }
        });

        break;

      default:
        result.notImplemented();
        break;
    }
  }

  @Override
  public void onListen(Object o, final EventChannel.EventSink eventSink) {
    AndroidPrintSdk.getInstance(mActivity).setPrintDeviceMsgListener(new AndroidPrintSdk.PrintDeviceMsgListener() {
      @Override
      public void printerMsg(LinkedHashMap<String, String> map) {
        if (map.size() > 0)
          eventSink.success(map);
        else
          eventSink.error("", "", null);
      }
    });
  }

  @Override
  public void onCancel(Object o) {

  }
}
