package com.example.kpprinter.java;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;

import com.qw.soul.permission.SoulPermission;
import com.qw.soul.permission.bean.Permission;
import com.qw.soul.permission.callbcak.CheckRequestPermissionsListener;

import java.util.ArrayList;
import java.util.List;


public class PermissionsAdapter implements CheckRequestPermissionsListener {
    private String message;
    private String msg2;
    private String  msgBtn;
    private String  msgBtn2;
    private String title;
    private Runnable retryRunnable;

    private List<Integer> listTrue = new ArrayList<>();
    private AlertDialog dialog;

    /**
     * @param message 当用户首次拒绝弹框时候，根据权限不同给用户不同的文案解释
     * @param retryRunnable    用户点重新授权的runnable 即重新执行原方法
     */
    public PermissionsAdapter(String title, String message, String msg2,String msgBtn,String msgBtn2,Runnable retryRunnable) {
        this.message = message;
        this.msg2 = msg2;
        this.msgBtn = msgBtn;
        this.msgBtn2 = msgBtn2;
        this.title = title;
        this.retryRunnable = retryRunnable;
    }


    @Override
    public void onAllPermissionOk(Permission[] permissions) {

    }

    @Override
    public void onPermissionDenied(Permission[] permissions) {
        Activity activity = SoulPermission.getInstance().getTopActivity();
        if (null == activity) {
            return;
        }

        //绿色框中的流程
        //用户第一次拒绝了权限、并且没有勾选"不再提示"这个值为true，此时告诉用户为什么需要这个权限。
        for (int i = 0;i<permissions.length;i++){
            if (permissions[i].shouldRationale()){
                listTrue.add(i);
            }
        }
        if (listTrue.size()==permissions.length) {
            AlertDialog.Builder builder = new AlertDialog.Builder(activity);
            builder.setTitle(title)
                    .setMessage(message)
                    .setPositiveButton(msgBtn, new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialogInterface, int i) {
                            //用户确定以后，重新执行请求原始流程
                            retryRunnable.run();
                        }
                    });
            dialog =builder.create();
            dialog.show();
        } else {
            //此时请求权限会直接报未授予，需要用户手动去权限设置页，所以弹框引导用户跳转去设置页
            String permissionDesc = permissions[0].getPermissionNameDesc();
            AlertDialog.Builder builder = new AlertDialog.Builder(activity);
            builder.setTitle(title)
                    .setMessage(permissionDesc+msg2)
                    .setPositiveButton(msgBtn2,
                            new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialogInterface, int i) {
                                    //去设置页
                                    SoulPermission.getInstance().goPermissionSettings();
                                }
                            });
                            dialog = builder.create();
                            dialog.show();
        }
        listTrue.clear();
    }


}
